import 'package:flutter/material.dart';

class AppTheme {
  const AppTheme._();

  static ThemeMode get getCurrentThemeMode {
    return ThemeMode.light;
  }

  // static ThemeData darkTheme = _darkThemeData();
  // static ThemeData lightTheme = _lightThemeData();

  /// The app was designed in a dark theme mode so, there's no light theme data
  /// for now
  // static final _lightTheme = ThemeData();

  // static _darkThemeData([ColorScheme? colorScheme]) => ThemeData(
  //       brightness: colorScheme!.brightness,
  //       primaryColor: colorScheme.primary,
  //       accentColor: colorScheme.secondary,
  //       backgroundColor: colorScheme.background,
  //       scaffoldBackgroundColor: colorScheme.background,
  //       textTheme: _textTheme(colorScheme),
  //       highlightColor: Colors.red,
  //       splashColor: Colors.red,
  //       primaryIconTheme: IconThemeData(color: colorScheme.onBackground),
  //       visualDensity: VisualDensity.adaptivePlatformDensity,
  //     );

  // /// App Color Scheme
  // static TextTheme _textTheme(ColorScheme colorScheme) => TextTheme(
  //       headline2: TextStyle(
  //         fontSize: 32.0,
  //         fontWeight: FontWeight.w700,
  //         fontFamily: 'Jost',
  //         height: 1.3,
  //       ),
  //       headline3: TextStyle(
  //         fontSize: 24.0,
  //         color: kDarkNeutralBase,
  //         fontWeight: FontWeight.w700,
  //         fontFamily: 'Jost',
  //       ),
  //       headline4: TextStyle(
  //         fontSize: 24.0,
  //         color: kDarkNeutralBase,
  //         fontWeight: FontWeight.w400,
  //         fontFamily: 'Jost',
  //       ),
  //       headline5: TextStyle(
  //         fontSize: 18.0,
  //         fontWeight: FontWeight.bold,
  //       ),
  //       subtitle1: TextStyle(
  //         fontSize: 16,
  //         fontWeight: FontWeight.w500,
  //         fontFamily: 'Jost',
  //       ),
  //       subtitle2: TextStyle(
  //         fontSize: 14,
  //         fontWeight: FontWeight.w500,
  //         fontFamily: 'Jost',
  //       ),
  //       bodyText2: TextStyle(
  //         fontSize: 14,
  //         color: kDarkNeutralLighten3,
  //         fontFamily: 'Jost',
  //         fontWeight: FontWeight.w400,
  //       ),
  //       caption: TextStyle(
  //         fontSize: 12,
  //         fontFamily: 'Jost',
  //         fontWeight: FontWeight.w400,
  //       ),
  //     );

  // static _lightThemeData([ColorScheme? colorScheme]) => ThemeData(
  //       brightness: colorScheme!.brightness,
  //       primaryColor: colorScheme.primary,
  //       accentColor: colorScheme.secondary,
  //       backgroundColor: colorScheme.background,
  //       scaffoldBackgroundColor: colorScheme.background,
  //       textTheme: _textTheme(colorScheme),
  //       highlightColor: Colors.red,
  //       splashColor: Colors.red,
  //       primaryIconTheme: IconThemeData(color: colorScheme.onBackground),
  //       visualDensity: VisualDensity.adaptivePlatformDensity,
  //     );
}

MaterialColor createMaterialColor(Color color) {
  var strengths = <double>[.05];
  final swatch = <int, Color>{};
  final r = color.red, g = color.green, b = color.blue;

  for (var i = 1; i < 10; i++) {
    strengths.add(0.1 * i);
  }
  strengths.forEach((double strength) {
    final ds = 0.5 - strength;
    swatch[(strength * 1000).round()] = Color.fromRGBO(
      r + ((ds < 0 ? r : (255 - r)) * ds).round(),
      g + ((ds < 0 ? g : (255 - g)) * ds).round(),
      b + ((ds < 0 ? b : (255 - b)) * ds).round(),
      1,
    );
  });
  return MaterialColor(color.value, swatch);
}
