import 'package:get/get.dart';

class LoaderController extends GetxController {
  RxBool appLoading = false.obs;

  Future<void> loadAsyncProcess(dynamic Function() run,
      {bool blocking = true,
      Function(dynamic e)? onError,
      Function(dynamic e)? onSuccess,
      bool showError = true}) async {
    if (blocking) {
      appLoading.value = true;
    }
    try {
      dynamic res = await run();
      onSuccess?.call(res);
    } catch (e, s) {
      if (showError) {
        print(
          e,
        );
      }
      onError?.call(e);
    } finally {
      if (blocking) {
        appLoading.value = false;
      }
    }
  }

  static LoaderController get instance {
    return Get.find<LoaderController>();
  }
}

enum LoadingState { idle, loading, failed, success }
