// To parse this JSON data, do
//
//     final createComplaintDto = createComplaintDtoFromMap(jsonString);

import 'package:bento_support_flutter/models/client.model.dart';
import 'package:bento_support_flutter/models/organization.model.dart';
import 'package:meta/meta.dart';
import 'dart:convert';

class Complaint {
  Complaint({
    required this.isDeleted,
    required this.status,
    required this.assignees,
    required this.tags,
    required this.client,
    required this.organization,
    required this.createdAt,
    required this.updatedAt,
    required this.id,
  });

  bool isDeleted;
  String status;
  List<dynamic> assignees;
  List<String> tags;
  Client client;
  Organization organization;
  DateTime createdAt;
  DateTime updatedAt;
  String id;

  Complaint copyWith({
    bool? isDeleted,
    String? status,
    List<dynamic>? assignees,
    List<String>? tags,
    Client? client,
    Organization? organization,
    DateTime? createdAt,
    DateTime? updatedAt,
    String? id,
  }) =>
      Complaint(
        isDeleted: isDeleted ?? this.isDeleted,
        status: status ?? this.status,
        assignees: assignees ?? this.assignees,
        tags: tags ?? this.tags,
        client: client ?? this.client,
        organization: organization ?? this.organization,
        createdAt: createdAt ?? this.createdAt,
        updatedAt: updatedAt ?? this.updatedAt,
        id: id ?? this.id,
      );

  factory Complaint.fromMap(Map<String, dynamic> json) => Complaint(
        isDeleted: json['isDeleted'] as bool,
        status: json['status'] as String,
        assignees:
            (json['assignees'] as List).map<dynamic>((dynamic x) => x).toList(),
        tags: (json['tags'] as List)
            .map<String>((dynamic x) => x.toString())
            .toList(),
        client: Client<String>.fromMap(json['client'] as Map<String, dynamic>),
        organization:
            Organization.fromJson(json['organization'] as Map<String, dynamic>),
        createdAt: DateTime.parse(json['createdAt'] as String),
        updatedAt: DateTime.parse(json['updatedAt'] as String),
        id: json['id'] as String,
      );

  Map<String, dynamic> toMap() => <String, dynamic>{
        'isDeleted': isDeleted,
        'status': status,
        'assignees': List<dynamic>.from(
            assignees.map<String>((dynamic x) => x.toString())),
        'tags': List<dynamic>.from(tags.map<dynamic>((dynamic x) => x)),
        'client': client.toMap(),
        'organization': organization.toJson(),
        'createdAt': createdAt.toIso8601String(),
        'updatedAt': updatedAt.toIso8601String(),
        'id': id,
      };
}
