// To parse this JSON data, do
//
//     final createComplaintDto = createComplaintDtoFromMap(jsonString);

import 'package:meta/meta.dart';
import 'dart:convert';

class CreateComplaintDto {
  CreateComplaintDto({
    required this.name,
    required this.email,
    this.clientReference,
    required this.phoneNumber,
    required this.tags,
  });

  String name;
  String email;
  String? clientReference;
  String phoneNumber;
  List<String> tags;

  CreateComplaintDto copyWith({
    String? name,
    String? email,
    String? clientReference,
    String? phoneNumber,
    List<String>? tags,
  }) =>
      CreateComplaintDto(
        name: name ?? this.name,
        email: email ?? this.email,
        clientReference: clientReference ?? this.clientReference,
        phoneNumber: phoneNumber ?? this.phoneNumber,
        tags: tags ?? this.tags,
      );

  factory CreateComplaintDto.fromJson(Map<String, dynamic> d) =>
      CreateComplaintDto.fromMap(d);

  String toJson() => json.encode(toMap());

  factory CreateComplaintDto.fromMap(Map<String, dynamic> json) =>
      CreateComplaintDto(
        name: json['name'] as String,
        email: json['email'] as String,
        clientReference: json['clientReference'] as String,
        phoneNumber: json['phoneNumber'] as String,
        tags: (json['tags'] as List).map((dynamic x) => x as String).toList(),
      );

  Map<String, dynamic> toMap() => <String, dynamic>{
        'name': name,
        'email': email,
        'clientReference': clientReference,
        'phoneNumber': phoneNumber,
        'tags': tags,
      };
}
