class PaginationMetadata {
  PaginationMetadata({
    required this.page,
    required this.perPage,
    required this.total,
    required this.pageCount,
  });
  late int page;
  late int perPage;
  late int total;
  late int pageCount;

  PaginationMetadata.fromJson(Map<String, dynamic> json) {
    page = json['page'] as int;
    perPage = json['perPage'] as int;
    total = json['total'] as int;
    pageCount = json['pageCount'] as int;
  }

  Map<String, dynamic> toJson() {
    final _data = <String, dynamic>{};
    _data['page'] = page;
    _data['perPage'] = perPage;
    _data['total'] = total;
    _data['pageCount'] = pageCount;
    return _data;
  }

  PaginationMetadata copyWith(
      {int? page, int? perPage, int? total, int? pageCount}) {
    return PaginationMetadata(
      page: page ?? this.page,
      total: total ?? this.total,
      pageCount: pageCount ?? this.pageCount,
      perPage: perPage ?? this.perPage,
    );
  }
}
