import 'package:bento_support_flutter/models/client.model.dart';
import 'package:bento_support_flutter/models/user.model.dart';
import 'package:bento_support_flutter/services/api/api_response.dart';
import 'package:bento_support_flutter/services/api/api_services.dart';

class ClientService {
  static Future<ApiResponse<Client>> fetchSingleClient(String clientReference) {
    return ApiServices.get(
        path: '/client/$clientReference',
        toModel: (dynamic d) {
          return Client<String>.fromMap(d as Map<String, dynamic>);
        });
  }

  static Future<ApiResponse<Client>> createClient(CreateClientDTO payload) {
    return ApiServices.post(
        path: '/client',
        data: payload.toMap,
        toModel: (dynamic d) {
          return Client<String>.fromMap(d as Map<String, dynamic>);
        });
  }
}
