import 'dart:convert';
import 'dart:developer';

import 'package:bento_support_flutter/models/complaint.dart';
import 'package:bento_support_flutter/models/dtos/create_complaint_dto.dart';
import 'package:bento_support_flutter/models/organization.model.dart';
import 'package:bento_support_flutter/services/api/api_response.dart';
import 'package:bento_support_flutter/services/api/api_services.dart';

class ComplaintService {
  static Future<ApiResponse<Complaint>> createComplaint(
      CreateComplaintDto complaint) {
    return ApiServices.post(
        path: '/complaints',
        data: complaint.toMap(),
        toModel: (dynamic d) {
          return Complaint.fromMap(d as Map<String, dynamic>);
        });
  }

  static Future<ApiResponse<Complaint?>> fetchClientLastComplaint(
      String clientId) {
    return ApiServices.get<Complaint?>(
        path: '/complaints/$clientId/last-open',
        toModel: (dynamic d) {
          if (d == null) return null;
          return Complaint.fromMap(d as Map<String, dynamic>);
        });
  }
}
