import 'dart:typed_data';
import 'package:file_picker/file_picker.dart';
import 'package:http/http.dart' as http;
import 'package:intl/intl.dart';
import 'package:path/path.dart' as p;

class ParserService {
  static bool fileIsImage(String filePath) {
    return ['.png', '.jpg'].contains(p.extension(filePath));
  }

  static Future<Uint8List> getBytesFromUrl(String url) async {
    final response = await http.get(Uri.parse(url));
    return response.bodyBytes;
  }

  static Future<Uint8List> getBytesFromFile(PlatformFile file) async {
    var byte = (await file.readStream?.toList()) ?? [];
    var data = <int>[];
    for (var i = 0; i < byte.length; i++) {
      data.addAll(byte[i]);
    }
    return Uint8List.fromList(data);
  }

  static String parseDateToString(DateTime date, String format) {
    return DateFormat(format).format(date);
  }
}
